Index: TWiki/Merge.pm
===================================================================
--- TWiki/Merge.pm	(revision 13172)
+++ TWiki/Merge.pm	(working copy)
@@ -35,14 +35,13 @@
 
 =pod
 
----++ StaticMethod merge2( $arev, $a, $brev, $b, $sep, $session, $info )
+---++ StaticMethod merge2( $arev, $a, $brev, $b, $sep, $info )
 
    * =$arev= - rev for $a (string)
    * =$a= - first ('original') string
    * =$brev= - rev for $b (string)
    * =$b= - second ('new') string
    * =$sep= = separator, string RE e.g. '.*?\n' for lines
-   * =$session= - TWiki object
    * =$info= - data block passed to plugins merge handler. Conventionally this will identify the source of the text being merged (the source form field, or undef for the body text)
 
 Perform a merge of two versions of the same text, using
@@ -63,19 +62,17 @@
 Call it like this:
 <verbatim>
 $newText = TWiki::Merge::merge2(
-   $oldrev, $old, $newrev, $new, '.*?\n', $session, $info );
+   $oldrev, $old, $newrev, $new, '.*?\n', $info );
 </verbatim>
 
 =cut
 
 sub merge2 {
-    my ( $va, $ia, $vb, $ib, $sep, $session, $info ) = @_;
+    my ( $va, $ia, $vb, $ib, $sep, $info ) = @_;
 
     my @a = split( /($sep)/, $ia );
     my @b = split( /($sep)/, $ib );
 
-    ASSERT($session && $session->isa('TWiki')) if DEBUG;
-
     my @out;
     Algorithm::Diff::traverse_balanced( \@a, \@b,
                                         {
@@ -88,19 +85,16 @@
                                         \@out,
                                         \@a,
                                         \@b,
-                                        $session,
                                         $info );
     return join( '', @out );
 }
 
 sub _acceptA {
-    my ( $a, $b, $out, $ai, $bi, $session, $info ) = @_;
+    my ( $a, $b, $out, $ai, $bi, $info ) = @_;
 
-    ASSERT($session->isa('TWiki')) if DEBUG;
-
     #print STDERR "From A: '$ai->[$a]'\n";
     # accept text from the old version without asking for resolution
-    my $merged = $session->{plugins}->mergeHandler(
+    my $merged = $TWiki::PLUGINS->mergeHandler(
         ' ',  $ai->[$a], undef, $info );
     if( defined $merged ) {
         push( @$out, $merged );
@@ -110,12 +104,10 @@
 }
 
 sub _acceptB {
-    my ( $a, $b, $out, $ai, $bi, $session, $info ) = @_;
+    my ( $a, $b, $out, $ai, $bi, $info ) = @_;
 
-    ASSERT($session->isa('TWiki')) if DEBUG;
-
     #print STDERR "From B: '$bi->[$b]'\n";
-    my $merged = $session->{plugins}->mergeHandler(
+    my $merged = $TWiki::PLUGINS->mergeHandler(
         ' ',  $bi->[$b], undef, $info );
     if( defined $merged ) {
         push( @$out, $merged );
@@ -125,9 +117,8 @@
 }
 
 sub _change {
-    my ( $a, $b, $out, $ai, $bi, $session, $info ) = @_;
+    my ( $a, $b, $out, $ai, $bi, $info ) = @_;
     my $merged;
-    ASSERT($session->isa('TWiki')) if DEBUG;
 
     # Diff isn't terribly smart sometimes; it will generate changes
     # with a or b empty, which I would have thought should have
@@ -136,7 +127,7 @@
         # there is some non-white text to delete
         if( $bi->[$b] =~ /\S/ ) {
             # this insert is replacing something with something
-            $merged = $session->{plugins}->mergeHandler(
+            $merged = $TWiki::PLUGINS->mergeHandler(
                 'c', $ai->[$a], $bi->[$b], $info );
             if( defined $merged ) {
                 push( @$out, $merged );
@@ -145,7 +136,7 @@
                 push( @$out, CGI::ins( $bi->[$b] ) );
             }
         } else {
-            $merged = $session->{plugins}->mergeHandler(
+            $merged = $TWiki::PLUGINS->mergeHandler(
                 '-',  $ai->[$a], $bi->[$b], $info );
             if( defined $merged ) {
                 push( @$out, $merged );
@@ -155,7 +146,7 @@
         }
     } elsif ( $bi->[$b] =~ /\S/ ) {
         # inserting new
-        $merged = $session->{plugins}->mergeHandler(
+        $merged = $TWiki::PLUGINS->mergeHandler(
             '+',  $ai->[$a], $bi->[$b], $info );
         #print STDERR "From B: '$bi->[$b]'\n";
         if( defined $merged ) {
@@ -166,7 +157,7 @@
     } else {
         # otherwise this insert is not replacing anything
         #print STDERR "From B: '$bi->[$b]'\n";
-        $merged = $session->{plugins}->mergeHandler(
+        $merged = $TWiki::PLUGINS->mergeHandler(
             ' ',  $ai->[$a], $bi->[$b], $info );
         if( defined $merged ) {
             push( @$out, $merged );
@@ -257,8 +248,7 @@
 
 =pod
 
----++ StaticMethod merge3( $arev, $a, $brev, $b, $crev, $c, $sep,
-                          $session, $info )
+---++ StaticMethod merge3( $arev, $a, $brev, $b, $crev, $c, $sep, $info )
 
    * =$arev= - rev for common ancestor (id e.g. ver no)
    * =$a= - common ancestor
@@ -267,7 +257,6 @@
    * =$crev= - rev no for second derivative string (id)
    * =$c= - second derivative string
    * =$sep= = separator, string RE e.g. '.*?\n' for lines
-   * =$session= - TWiki object
    * =$info= - data block passed to plugins merge handler. Conventionally this will identify the source of the text being merged (the source form field, or undef for the body text)
 
 Perform a merge of two versions (b and c) of the same text, using
@@ -302,7 +291,7 @@
 =cut
 
 sub merge3 {
-    my ( $arev, $ia, $brev, $ib, $crev, $ic, $sep, $session, $info ) = @_;
+    my ( $arev, $ia, $brev, $ib, $crev, $ic, $sep, $info ) = @_;
 
     $sep = "\r?\n" if (!defined($sep));
 
@@ -422,14 +411,14 @@
                     _handleConflict(\@out,
                                     \@aconf, \@bconf, \@cconf,
                                    $arev, $brev, $crev, $sep,
-                                   $session, $info);
+                                   $info);
                     $conflict = 0;
                     push @out, @merged;
                     @merged = ();
                 }
             } else {
                 # the line is non-conflicting
-                my $merged = $session->{plugins}->mergeHandler(
+                my $merged = $TWiki::PLUGINS->mergeHandler(
                     ' ',  $dline, $dline, $info );
                 if( defined $merged ) {
                     push( @out, $merged );
@@ -450,7 +439,7 @@
         }
 
         _handleConflict(\@out, \@aconf, \@bconf, \@cconf,
-                       $arev, $brev, $crev, $sep, $session, $info);
+                       $arev, $brev, $crev, $sep, $info);
     }
     push @out, @merged;
     @merged = ();
@@ -465,14 +454,13 @@
 my $conflictB = CGI::b('CONFLICT');
 
 sub _handleConflict {
-    my( $out, $aconf, $bconf, $cconf, $arev, $brev, $crev,
-        $sep, $session, $info ) = @_;
+    my( $out, $aconf, $bconf, $cconf, $arev, $brev, $crev, $sep, $info ) = @_;
     my( @a, @b, @c );
 
     @a = grep( $_, @$aconf );
     @b = grep( $_, @$bconf );
     @c = grep( $_, @$cconf );
-    my $merged = $session->{plugins}->mergeHandler(
+    my $merged = $TWiki::PLUGINS->mergeHandler(
         'c',  join( '', @b ), join( '', @c ), $info);
     if( defined $merged ) {
         push( @$out, $merged );
Index: TWiki/Access.pm
===================================================================
--- TWiki/Access.pm	(revision 13172)
+++ TWiki/Access.pm	(working copy)
@@ -40,10 +40,8 @@
 =cut
 
 sub new {
-    my ( $class, $session ) = @_;
+    my ( $class ) = @_;
     my $this = bless( {}, $class );
-    ASSERT($session->isa( 'TWiki')) if DEBUG;
-    $this->{session} = $session;
 
     %{$this->{GROUPS}} = ();
 
@@ -97,7 +95,7 @@
 
     $mode = uc( $mode );  # upper case
 
-    my $prefs = $this->{session}->{prefs};
+    my $prefs = $TWiki::PREFS;
 
     my $allowText;
     my $denyText;
@@ -120,7 +118,7 @@
     if( defined( $denyText )) {
         if( $denyText =~ /\S$/ ) {
             if( $user->isInList( $denyText )) {
-                $this->{failure} = $this->{session}->{i18n}->maketext('access denied on topic');
+                $this->{failure} = $TWiki::I18N->maketext('access denied on topic');
                 #print STDERR $this->{failure},"\n";
                 return 0;
             }
@@ -137,7 +135,7 @@
             #print STDERR "in ALLOWTOPIC\n";
             return 1;
         }
-        $this->{failure} = $this->{session}->{i18n}->maketext('access not allowed on topic');
+        $this->{failure} = $TWiki::I18N->maketext('access not allowed on topic');
         #print STDERR $this->{failure},"\n";
         return 0;
     }
@@ -148,7 +146,7 @@
         $denyText =
           $prefs->getWebPreferencesValue( 'DENYWEB'.$mode, $web );
         if( defined( $denyText ) && $user->isInList( $denyText )) {
-            $this->{failure} = $this->{session}->{i18n}->maketext('access denied on web');
+            $this->{failure} = $TWiki::I18N->maketext('access denied on web');
             #print STDERR $this->{failure},"\n";
             return 0;
         }
@@ -160,7 +158,7 @@
 
     if( defined( $allowText ) && $allowText =~ /\S/ ) {
         unless( $user->isInList( $allowText )) {
-            $this->{failure} = $this->{session}->{i18n}->maketext('access not allowed on web');
+            $this->{failure} = $TWiki::I18N->maketext('access not allowed on web');
             #print STDERR $this->{failure},"\n";
             return 0;
         }
@@ -171,7 +169,7 @@
         $denyText =
           $prefs->getPreferencesValue( 'DENYROOT'.$mode, $web );
         if( defined( $denyText ) && $user->isInList( $denyText )) {
-            $this->{failure} = $this->{session}->{i18n}->maketext('access denied on root');
+            $this->{failure} = $TWiki::I18N->maketext('access denied on root');
             #print STDERR $this->{failure},"\n";
             return 0;
         }
@@ -180,7 +178,7 @@
 
         if( defined( $allowText ) && $allowText =~ /\S/ ) {
             unless( $user->isInList( $allowText )) {
-                $this->{failure} = $this->{session}->{i18n}->maketext('access not allowed on root');
+                $this->{failure} = $TWiki::I18N->maketext('access not allowed on root');
                 #print STDERR $this->{failure},"\n";
                 return 0;
             }
Index: TWiki/Users.pm
===================================================================
--- TWiki/Users.pm	(revision 13172)
+++ TWiki/Users.pm	(working copy)
@@ -43,30 +43,27 @@
 
 =pod
 
----++ ClassMethod new ($session, $impl)
+---++ ClassMethod new ($impl)
 
 Construct the user management object
 
 =cut
 
 sub new {
-    my ( $class, $session ) = @_;
-    ASSERT($session->isa( 'TWiki')) if DEBUG;
+    my ( $class ) = @_;
     my $this = bless( {}, $class );
 
-    $this->{session} = $session;
-
     my $implPasswordManager = $TWiki::cfg{PasswordManager};
     $implPasswordManager = 'TWiki::Users::Password' if( $implPasswordManager eq 'none' );
     eval "use $implPasswordManager";
     die "Password Manager: $@" if $@;
-    $this->{passwords} = $implPasswordManager->new( $session );
+    $this->{passwords} = $implPasswordManager->new();
 
     my $implUserMappingManager = $TWiki::cfg{UserMappingManager};
     $implUserMappingManager = 'TWiki::Users::TWikiUserMapping' if( $implUserMappingManager eq 'none' );
     eval "use $implUserMappingManager";
     die "User Mapping Manager: $@" if $@;
-    $this->{usermappingmanager} = $implUserMappingManager->new( $session );
+    $this->{usermappingmanager} = $implUserMappingManager->new();
 
     $this->{login} = {};
     $this->{wikiname} = {};
@@ -155,7 +152,7 @@
     $name ||= $TWiki::cfg{DefaultUserLogin};
     my $object;
 
-    #$this->{session}->writeDebug("Looking for $name / $wikiname / $dontCreate");
+    #$TWiki::SESSION->writeDebug("Looking for $name / $wikiname / $dontCreate");
 
     # is it a cached login name?
     $object = $this->{login}{$name};
@@ -206,7 +203,7 @@
         # default to wikiname being the same as name.
         # Commented out because this warning is too common, and tends to
         # flood the logs.
-        # $this->{session}->writeWarning("$name does not exist in TWikiUsers - is this a bogus user?") unless( $name =~ /Group$/ );
+        # $TWiki::SESSION->writeWarning("$name does not exist in TWikiUsers - is this a bogus user?") unless( $name =~ /Group$/ );
         $wikiname = $name;
     }
 
@@ -241,7 +238,7 @@
 sub createUser {
     my( $this, $name, $wikiname ) = @_;
 
-    my $object = new TWiki::User( $this->{session}, $name, $wikiname );
+    my $object = new TWiki::User( $name, $wikiname );
     if ( defined ($object) ) {
         $this->{login}{$object->login()} = $object;
         $this->{wikiname}{$object->webDotWikiName()} = $object;
